VERSION 5.00
Begin VB.Form BoardNum 
   Caption         =   "PCI Data Acquisition Cards Serial Number Test"
   ClientHeight    =   6135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6030
   LinkTopic       =   "Form1"
   ScaleHeight     =   6135
   ScaleWidth      =   6030
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Enumerate Boards"
      Height          =   2415
      Left            =   120
      TabIndex        =   7
      Top             =   2280
      Width           =   5775
      Begin VB.CommandButton ListBoards 
         Caption         =   "&List All Boards In System"
         Height          =   615
         Left            =   240
         TabIndex        =   9
         Top             =   1680
         Width           =   5295
      End
      Begin VB.TextBox BoardList 
         Height          =   1095
         Left            =   240
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   8
         Top             =   360
         Width           =   5295
      End
   End
   Begin VB.TextBox BoardNum 
      Height          =   375
      Left            =   3360
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   720
      Width           =   1935
   End
   Begin VB.Frame Frame1 
      Caption         =   "Board Index Number"
      Height          =   2055
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5775
      Begin VB.CommandButton GetBoardNum 
         Caption         =   "&Get Board Serial Number"
         Height          =   615
         Left            =   240
         TabIndex        =   4
         Top             =   1200
         Width           =   5295
      End
      Begin VB.TextBox SerNum 
         Alignment       =   1  'Right Justify
         Height          =   375
         Left            =   480
         TabIndex        =   2
         Top             =   600
         Width           =   1935
      End
      Begin VB.Label Label2 
         Alignment       =   2  'Center
         Caption         =   "Board and Index Number"
         Height          =   255
         Left            =   3240
         TabIndex        =   6
         Top             =   360
         Width           =   1935
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Serial Number (Hex)"
         Height          =   255
         Left            =   480
         TabIndex        =   5
         Top             =   360
         Width           =   1935
      End
   End
   Begin VB.TextBox Status 
      Height          =   1215
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   4800
      Width           =   5775
   End
End
Attribute VB_Name = "BoardNum"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------
' (C)2000 Blue Chip Technology Ltd.  All Rights Reserved.
'----------------------------------------------------------------
'
'  FileName  : $Workfile::                                     $
'
'  Release   : 1.00
'
'  Contents  : This file contains the sample application for
'              getting board id numbers from a given serial
'              number and producing an enumerated list for all
'              the boards in the system
'
'  History   :
'  $Revision::                                                 $
'  $Author::                                                   $
'  $Modtime::                                                  $
'  $History::                                                  $
'
'----------------------------------------------------------------
Dim nStatus As Long
Dim szErrorText As String
Dim szText As String

'---------------------------------------------------------------
' OutputMessage - Adds a message to the status box
'
' Input  : szErr - Error message to add to text box called Status
' Return : None
'---------------------------------------------------------------
Private Sub OutputMessage(szErr As String)
    Status.Text = szErr + Chr$(13) + Chr$(10) + Status.Text
End Sub


'---------------------------------------------------------------
' GetBoardNum_Click - Convert the serial number into a board
'                     type and display it and it's index number
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub GetBoardNum_Click()

szErrorText = Space(120)
szText = Space(120)
Dim nBoardType As Integer
Dim nBoardNo As Integer

    '---------------------------------------------------------------
    ' Display a message that we are about to get the board id num
    '---------------------------------------------------------------
    OutputMessage ("About to call BCTFindBoardNo to get board number")
    
    '---------------------------------------------------------------
    ' Make the call
    '---------------------------------------------------------------
    nStatus = BCTFindBoardNo(Val("&H" + SerNum.Text), nBoardType, nBoardNo)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTFindBoardNo returned: " + szErrorText)
    Else
        If nBoardType = PCI_PIO Then
            szText = "PCI-PIO"
        End If
        If nBoardType = PCI_DIO Then
            szText = "PCI-DIO"
        End If
        If nBoardType = PCI_ADC Then
            szText = "PCI-ADC"
        End If
        If nBoardType = PCI_WDT Then
            szText = "PCI-WDT"
        End If
        If nBoardType = PCI_RLY Then
            szText = "PCI-RLY"
        End If
        szText = szText + " Index number: " + Str(nBoardNo)
        BoardNum.Text = szText
    End If
    
End Sub

'---------------------------------------------------------------
' ListBoards_Click - Work through all the boards in the system
'                    and return their type, the serial number
'                    and their index number.
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub ListBoards_Click()

szErrorText = Space(120)
szText = Space(120)
Dim nBoardType As Integer
Dim nBoardNo As Integer
Dim nSerialNumber As Long
Dim nIndex As Integer

    '---------------------------------------------------------------
    ' Work in a loop starting at 0 and keep cycling through until
    ' we get a return code of BCTERR_PCI_BOARD_NOT_FOUND
    '---------------------------------------------------------------
    nIndex = 0
    
    Do
        nStatus = BCTEnumerateBoards(nIndex, nBoardType, nBoardNo, nSerialNumber)
        If (nStatus = BCT_OK) Then
            szText = "Board " + Str(nIndex) + " "
            If nBoardType = PCI_PIO Then
                szText = szText + "PCI-PIO"
            End If
            If nBoardType = PCI_DIO Then
                szText = szText + "PCI-DIO"
            End If
            If nBoardType = PCI_ADC Then
                szText = szText + "PCI-ADC"
            End If
            If nBoardType = PCI_WDT Then
                szText = szText + "PCI-WDT"
            End If
            If nBoardType = PCI_RLY Then
                szText = szText + "PCI-RLY"
            End If
            szText = szText + " serial number " + Hex(nSerialNumber) + " index " + Str(nBoardNo)
            BoardList.Text = BoardList.Text + szText + Chr$(13) + Chr$(10)
        End If
        
        ' Move onto the next board
        nIndex = nIndex + 1
    Loop While nStatus <> BCTERR_PCI_BOARD_NOT_FOUND
    
End Sub
