VERSION 5.00
Begin VB.Form AutoCalMain 
   Caption         =   "PCI-ADC AutoCalibration"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5520
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5520
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Status 
      Height          =   1215
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   1920
      Width           =   5295
   End
   Begin VB.CommandButton AutoCal 
      Caption         =   "Run BCTAutoCalibrateAin"
      Height          =   615
      Left            =   120
      TabIndex        =   4
      Top             =   1200
      Width           =   5295
   End
   Begin VB.TextBox MeanFsd 
      Height          =   375
      Left            =   1200
      TabIndex        =   3
      Top             =   600
      Width           =   4215
   End
   Begin VB.TextBox MeanZero 
      Height          =   375
      Left            =   1200
      TabIndex        =   1
      Top             =   120
      Width           =   4215
   End
   Begin VB.Label Label2 
      Caption         =   "Mean FSD"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Mean Zero"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   855
   End
End
Attribute VB_Name = "AutoCalMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --------------------------------------------------------------
' Define the global variables for the handles and board ID.
' --------------------------------------------------------------
Dim nStatus As Long
Dim szErrorText As String
Dim nPciAdcAnalInHandle As BCT_HANDLE
Dim pPciAdcBoardId As BCT_BOARD_ID

'---------------------------------------------------------------
' OutputMessage - Adds a message to the status box
'
' Input  : szErr - Error message to add to text box called Status
' Return : None
'---------------------------------------------------------------
Private Sub OutputMessage(szErr As String)
    Status.Text = szErr + Chr$(13) + Chr$(10) + Status.Text
End Sub
Private Sub AutoCal_Click()
    ' Redefine the storage for the error handler
    szErrorText = Space(120)
    ' Define the variables for the averages returned from the board.
    Dim nMeanZero As Integer
    Dim nMeanFsd As Integer

    '---------------------------------------------------------------
    ' Open the handle for getting the analogue data
    '---------------------------------------------------------------
    nStatus = BCTOpen(nPciAdcAnalInHandle, pPciAdcBoardId, BCT_AIN, 0, 0)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If

    '---------------------------------------------------------------
    ' Call the auto calibrate function of the PCI-ADC
    '---------------------------------------------------------------
    nStatus = BCTAutoCalAin(nPciAdcAnalInHandle, PCIADC_AIN_GAIN_1, nMeanZero, nMeanFsd)
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciAdcAnalInHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTAutoCalAin returned: " + szErrorText)
    Else
        MeanZero.Text = Hex(nMeanZero) + " hex"
        MeanFsd.Text = Hex(nMeanFsd) + " hex"
    End If
    
    '---------------------------------------------------------------
    ' Close the handle for analogue input 0
    '---------------------------------------------------------------
    nStatus = BCTClose(nPciAdcAnalInHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTClose returned: " + szErrorText)
    End If
End Sub

Private Sub Form_Load()
    ' Redefine the storage space for the error handle
    szErrorText = Space(120)

    '---------------------------------------------------------------
    ' Start by initialising the handles that we require
    '---------------------------------------------------------------
    OutputMessage ("Initialising handles for use by the IO tests")
    nStatus = BCTInitHandle(nPciAdcAnalInHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
   
    '---------------------------------------------------------------
    ' Next get the driver to fill in the board ID structure for the
    ' PCI-ADC
    '---------------------------------------------------------------
    OutputMessage ("Setting up the board ID structure")
    nStatus = BCTGetBoardId(pPciAdcBoardId, PCI_ADC, 0)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTGetBoardId returned: " + szErrorText)
    End If
End Sub

'---------------------------------------------------------------
' Form_Unload - Close the handle and release the board id
'               structure.  No error handling here as we aren't
'               allowed access to the form as it is in the
'               process of being destroyed.
'
' Input  : None
' Return : None
'---------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)

    '---------------------------------------------------------------
    ' Release the board ID
    '---------------------------------------------------------------
    nStatus = BCTReleaseBoardId(pPciAdcBoardId)
End Sub
