VERSION 5.00
Begin VB.Form Piocount 
   Caption         =   "PCI-PIO Counter"
   ClientHeight    =   3135
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5910
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   5910
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Status 
      Height          =   1095
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   1920
      Width           =   5655
   End
   Begin VB.Timer GetCount 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   3720
      Top             =   840
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Sto&p"
      Height          =   495
      Left            =   3120
      TabIndex        =   2
      Top             =   1320
      Width           =   2655
   End
   Begin VB.CommandButton Start 
      Caption         =   "&Start"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1320
      Width           =   2655
   End
   Begin VB.Label CountVal 
      Alignment       =   2  'Center
      Caption         =   "FFFF"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   48
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5655
   End
End
Attribute VB_Name = "piocount"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------
' (C)2000 Blue Chip Technology Ltd.  All Rights Reserved.
'----------------------------------------------------------------
'
'  FileName  : $Workfile::                                     $
'
'  Release   : 1.00
'
'  Contents  : This file contains the sample application for
'              counting using the PCI-PIO counter 0 external
'              input 2.
'
'  History   :
'  $Revision::                                                 $
'  $Author::                                                   $
'  $Modtime::                                                  $
'  $History::                                                  $
'
'----------------------------------------------------------------
Dim nStatus As Long
Dim szErrorText As String
Dim szText As String
Dim nPciPioHandle As BCT_HANDLE
Dim pPciPioBoardId As BCT_BOARD_ID

'---------------------------------------------------------------
' OutputMessage - Adds a message to the status box
'
' Input  : szErr - Error message to add to text box called Status
' Return : None
'---------------------------------------------------------------
Private Sub OutputMessage(szErr As String)
    Status.Text = szErr + Chr$(13) + Chr$(10) + Status.Text
End Sub

'---------------------------------------------------------------
' Form_Load - Initialise a board ID structure for the PCI-PIO
'             and initialise and open a handle for a pacer
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub Form_Load()

szErrorText = Space(120)

    '---------------------------------------------------------------
    ' Start by initialising a handle
    '---------------------------------------------------------------
    OutputMessage ("Initialising a handle for use by the pacer")
    nStatus = BCTInitHandle(nPciPioHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Next get the driver to fill in the board ID structure for the
    ' PCI-PIO
    '---------------------------------------------------------------
    OutputMessage ("Setting up the board ID structure")
    nStatus = BCTGetBoardId(pPciPioBoardId, PCI_PIO, 0)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTGetBoardId returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' As we are counting with the PCI-PIO we need to ensure that
    ' all of the ports are set to input to stop any device contention.
    ' If in doubt see the section on couting in the PCI-PIO user manaual.
    '---------------------------------------------------------------
    OutputMessage ("Setting the PCI-PIO port directions")
    nStatus = BCTInit8255Modes(pPciPioBoardId, 0, MODE_0, INPUT8, INPUT8, ININ)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInit8255Modes returned: " + szErrorText)
    End If
    nStatus = BCTInit8255Modes(pPciPioBoardId, 1, MODE_0, INPUT8, INPUT8, ININ)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInit8255Modes returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Finally open the handle
    '---------------------------------------------------------------
    OutputMessage ("Opening the handle")
    nStatus = BCTOpen(nPciPioHandle, pPciPioBoardId, BCT_8254, 0, 0)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If

End Sub

'---------------------------------------------------------------
' Form_Unload - Close the handle and release the board id
'               structure.  No error handling here as we aren't
'               allowed access to the form as it is in the
'               process of being destroyed.
'
' Input  : None
' Return : None
'---------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)

    '---------------------------------------------------------------
    ' Make sure that the handle is closed
    '---------------------------------------------------------------
    nStatus = BCTClose(nPciPioHandle)

    '---------------------------------------------------------------
    ' Release the board ID
    '---------------------------------------------------------------
    nStatus = BCTReleaseBoardId(pPciPioBoardId)
    
End Sub

'---------------------------------------------------------------
' GetCount_Timer - Call the read function to get the count back
'                  from counter 0 on the PCI-PIO
'---------------------------------------------------------------

Private Sub GetCount_Timer()

Dim nVal As Integer

    '---------------------------------------------------------------
    ' Read the counter 0 back and display the value on the screen.
    ' As with all IO operations that the driver executes there is
    ' the possibility that there is already an operation within the
    ' system that hasn't been completed.  In order to handle this
    ' the driver will return BCT_IO_PENDING.  If it does then we can
    ' either specify that it waits a fixed period of time to see if
    ' it can complete the operation or we can make it wait until
    ' the operation has completed by specifying the appropriate time
    ' to BCTWait
    '---------------------------------------------------------------
    nStatus = BCTReadPort16(nPciPioHandle, nVal)
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciPioHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nSatus, szErrorText)
        OutputMessage ("BCTReadPort16 returned: " + szErrorText)
    Else
        CountVal.Caption = Hex(nVal)
    End If

End Sub

'---------------------------------------------------------------
' Start_Click - Start the counter running and kick off the
'               timer component to read the count back and
'               display it on the screen
'
' Input  : None
' Return : None
'---------------------------------------------------------------
Private Sub Start_Click()

szErrorText = Space(120)

    '---------------------------------------------------------------
    ' Program the counter 0 to count down using external input 2
    ' As with all IO operations that the driver executes there is
    ' the possibility that there is already an operation within the
    ' system that hasn't been completed.  In order to handle this
    ' the driver will return BCT_IO_PENDING.  If it does then we can
    ' either specify that it waits a fixed period of time to see if
    ' it can complete the operation or we can make it wait until
    ' the operation has completed by specifying the appropriate time
    ' to BCTWait
    '---------------------------------------------------------------
    OutputMessage ("About to program the counter")
    nStatus = BCTProgramCounter(nPciPioHandle, BCT_EXTERN_COUNTER_INPUT2)
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciPioHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nSatus, szErrorText)
        OutputMessage ("BCTProgramCounter returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Enable the timer
    '---------------------------------------------------------------
    GetCount.Enabled = True
    
End Sub

'---------------------------------------------------------------
' Stop_Click - Stop the timer component running
'---------------------------------------------------------------

Private Sub Stop_Click()

    '---------------------------------------------------------------
    ' Disable the timer
    '---------------------------------------------------------------
    GetCount.Enabled = False
    
End Sub
