VERSION 5.00
Begin VB.Form piotest 
   Caption         =   "PCI-PIO Test Program"
   ClientHeight    =   5895
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7095
   LinkTopic       =   "Form1"
   ScaleHeight     =   5895
   ScaleWidth      =   7095
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "PIO 1 - Paced IO"
      Height          =   2055
      Left            =   120
      TabIndex        =   2
      Top             =   2280
      Width           =   6855
      Begin VB.Timer ReadPacer 
         Enabled         =   0   'False
         Interval        =   30
         Left            =   6000
         Top             =   240
      End
      Begin VB.CommandButton StopPacer 
         Caption         =   "S&top Pacer"
         Height          =   615
         Left            =   3720
         TabIndex        =   8
         Top             =   1200
         Width           =   2535
      End
      Begin VB.CommandButton StartPacer 
         Caption         =   "Start &Pacer"
         Height          =   615
         Left            =   480
         TabIndex        =   7
         Top             =   1200
         Width           =   2535
      End
      Begin VB.TextBox PacerRead 
         Alignment       =   1  'Right Justify
         Height          =   375
         Left            =   2280
         Locked          =   -1  'True
         TabIndex        =   6
         Top             =   480
         Width           =   1935
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "PIO 0 - Direct IO"
      Height          =   2055
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6855
      Begin VB.CommandButton SetPio 
         Caption         =   "&Set PIO 0 port A and read PIO 0 port B"
         Height          =   615
         Left            =   600
         TabIndex        =   5
         Top             =   1200
         Width           =   5415
      End
      Begin VB.TextBox InVal 
         Alignment       =   1  'Right Justify
         Height          =   375
         Left            =   3720
         Locked          =   -1  'True
         TabIndex        =   4
         Top             =   480
         Width           =   2295
      End
      Begin VB.TextBox OutVal 
         Alignment       =   1  'Right Justify
         Height          =   375
         Left            =   600
         TabIndex        =   3
         Text            =   "00"
         Top             =   480
         Width           =   2295
      End
      Begin VB.Label Label2 
         Alignment       =   2  'Center
         Caption         =   "Port B Input value (hex)"
         Height          =   255
         Left            =   3720
         TabIndex        =   10
         Top             =   240
         Width           =   2295
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Port A Output value (hex)"
         Height          =   255
         Left            =   600
         TabIndex        =   9
         Top             =   240
         Width           =   2295
      End
   End
   Begin VB.TextBox Status 
      Height          =   1335
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   4440
      Width           =   6855
   End
End
Attribute VB_Name = "piotest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'----------------------------------------------------------------
' (C)2000 Blue Chip Technology Ltd.  All Rights Reserved.
'----------------------------------------------------------------
'
'  FileName  : $Workfile::                                     $
'
'  Release   : 1.00
'
'  Contents  : This file contains the sample application for
'              testing the loopback connections between PIO 0
'              ports A and B and between PIO 1 ports A and B.
'
'  History   :
'  $Revision::                                                 $
'  $Author::                                                   $
'  $Modtime::                                                  $
'  $History::                                                  $
'
'----------------------------------------------------------------
Dim nStatus As Long
Dim szErrorText As String
Dim szText As String
Dim nPciPio0PortAHandle As BCT_HANDLE
Dim nPciPio0PortBHandle As BCT_HANDLE
Dim nPciPio1PortAHandle As BCT_HANDLE
Dim nPciPio0PortCHandle As BCT_HANDLE
Dim pPciPioBoardId As BCT_BOARD_ID
Dim pPioBuffer As BCT_BUFFER

'---------------------------------------------------------------
' OutputMessage - Adds a message to the status box
'
' Input  : szErr - Error message to add to text box called Status
' Return : None
'---------------------------------------------------------------
Private Sub OutputMessage(szErr As String)
    Status.Text = szErr + Chr$(13) + Chr$(10) + Status.Text
End Sub


'---------------------------------------------------------------
' Form_Load - Initialise a board ID structure for the PCI-PIO
'             and initialise and open handles for the pacer and
'             direct IO.
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub Form_Load()

szErrorText = Space(120)
Dim nIndex As Integer

    '---------------------------------------------------------------
    ' Start by initialising the four handles that we require
    '---------------------------------------------------------------
    OutputMessage ("Initialising handles for use by the IO tests")
    nStatus = BCTInitHandle(nPciPio0PortAHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
    nStatus = BCTInitHandle(nPciPio0PortBHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
    nStatus = BCTInitHandle(nPciPio1PortAHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
    nStatus = BCTInitHandle(nPciPio0PortCHandle)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitHandle returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Next get the driver to fill in the board ID structure for the
    ' PCI-PIO
    '---------------------------------------------------------------
    OutputMessage ("Setting up the board ID structure")
    nStatus = BCTGetBoardId(pPciPioBoardId, PCI_PIO, 0)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTGetBoardId returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' The loop back tests that we are going to run are going to use
    ' port A as output and port B as input on BOTH PIO devices.  As
    ' such we need to set the ports to OUTPUT8, INPUT8, NOCARE.  The
    ' C header file defines the port directions as INPUT and OUTPUT
    ' however these are reserved words in Visual Basic and so they
    ' are defined as INPUT8 and OUTPUT8.
    '---------------------------------------------------------------
    OutputMessage ("Setting the PCI-PIO port directions")
    nStatus = BCTInit8255Modes(pPciPioBoardId, 0, MODE_0, OUTPUT8, INPUT8, ININ)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInit8255Modes returned: " + szErrorText)
    End If
    nStatus = BCTInit8255Modes(pPciPioBoardId, 1, MODE_0, OUTPUT8, NOCARE, NOCARE)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInit8255Modes returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Open the handle for the IO
    '---------------------------------------------------------------
    OutputMessage ("Opening the handles")
    nStatus = BCTOpen(nPciPio0PortAHandle, pPciPioBoardId, BCT_8255, 0, BCT_PORT_A)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If
    nStatus = BCTOpen(nPciPio0PortBHandle, pPciPioBoardId, BCT_8255, 0, BCT_PORT_B)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If
    nStatus = BCTOpen(nPciPio1PortAHandle, pPciPioBoardId, BCT_8255, 1, BCT_PORT_A)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If
    nStatus = BCTOpen(nPciPio0PortCHandle, pPciPioBoardId, BCT_8255, 0, BCT_PORT_C)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTOpen returned: " + szErrorText)
    End If

    '---------------------------------------------------------------
    ' Fill in the buffer that we will use for the pacer IO
    '---------------------------------------------------------------
    pPioBuffer.Length = 256
    For nIndex = 0 To 255
        pPioBuffer.Buffer(nIndex) = nIndex
    Next nIndex
    
End Sub

'---------------------------------------------------------------
' Form_Unload - Close the handle and release the board id
'               structure.  No error handling here as we aren't
'               allowed access to the form as it is in the
'               process of being destroyed.
'
' Input  : None
' Return : None
'---------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)

    '---------------------------------------------------------------
    ' Ensure that the pacer is stopped
    '---------------------------------------------------------------
    nStatus = BCTStopPacer(pPciPioBoardId)
    
    '---------------------------------------------------------------
    ' Make sure that the handles are closed
    '---------------------------------------------------------------
    nStatus = BCTClose(nPciPio0PortAHandle)
    nStatus = BCTClose(nPciPio0PortBHandle)
    nStatus = BCTClose(nPciPio1PortAHandle)
    nStatus = BCTClose(nPciPio0PortCHandle)

    '---------------------------------------------------------------
    ' Release the board ID
    '---------------------------------------------------------------
    nStatus = BCTReleaseBoardId(pPciPioBoardId)
    
End Sub

'---------------------------------------------------------------
' ReadPacer_Timer - Read the value back from PIO 1 port B and
'                   display it on the screen.
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub ReadPacer_Timer()

szErrorText = Space(120)
Dim nVal As Byte

    '---------------------------------------------------------------
    ' Read back the value on PIO 0 port C.
    ' As with all IO operations that the driver executes there is
    ' the possibility that there is already an operation within the
    ' system that hasn't been completed.  In order to handle this
    ' the driver will return BCT_IO_PENDING.  If it does then we can
    ' either specify that it waits a fixed period of time to see if
    ' it can complete the operation or we can make it wait until
    ' the operation has completed by specifying the appropriate time
    ' to BCTWait
    '---------------------------------------------------------------
    nStatus = BCTReadPort(nPciPio0PortCHandle, nVal)
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciPio0PortCHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nSatus, szErrorText)
        OutputMessage ("BCTReadPort returned: " + szErrorText)
    Else
        PacerRead.Text = Hex(nVal)
    End If

End Sub

'---------------------------------------------------------------
' SetPio_Click - Set the ouput on PIO 0 port A to the value
'                specified in the OutVal text box and read back
'                the value that appears on the inputs of PIO 0
'                port B and display this in the InVal text box.
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub SetPio_Click()

szErrorText = Space(120)
Dim nVal As Byte

    '---------------------------------------------------------------
    ' Write a value to PIO 0 port A.
    ' As with all IO operations that the driver executes there is
    ' the possibility that there is already an operation within the
    ' system that hasn't been completed.  In order to handle this
    ' the driver will return BCT_IO_PENDING.  If it does then we can
    ' either specify that it waits a fixed period of time to see if
    ' it can complete the operation or we can make it wait until
    ' the operation has completed by specifying the appropriate time
    ' to BCTWait
    '---------------------------------------------------------------
    OutputMessage ("Writing to PIO 0 port A")
    nStatus = BCTWritePort(nPciPio0PortAHandle, Val("&H" + OutVal.Text))
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciPio0PortAHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTWritePort returned: " + szErrorText)
    End If

    '---------------------------------------------------------------
    ' Read back the value on PIO 0 port B.
    ' As with all IO operations that the driver executes there is
    ' the possibility that there is already an operation within the
    ' system that hasn't been completed.  In order to handle this
    ' the driver will return BCT_IO_PENDING.  If it does then we can
    ' either specify that it waits a fixed period of time to see if
    ' it can complete the operation or we can make it wait until
    ' the operation has completed by specifying the appropriate time
    ' to BCTWait
    '---------------------------------------------------------------
    OutputMessage ("Reading back PIO 0 port B")
    nStatus = BCTReadPort(nPciPio0PortBHandle, nVal)
    If nStatus = BCT_IO_PENDING Then
        nStatus = BCTWait(nPciPio0PortBHandle, INFINITE)
    End If
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTReadPort returned: " + szErrorText)
    Else
        InVal.Text = Hex(nVal)
    End If

End Sub

'---------------------------------------------------------------
' StartPacer_Click - Start the output to PIO 1 port A using the
'                    values we loaded into the buffer
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub StartPacer_Click()
    
szErrorText = Space(120)
    
    '---------------------------------------------------------------
    ' Initialise the pacer on the PIO locally
    '---------------------------------------------------------------
    OutputMessage ("About to call BCTInitPacer")
    nStatus = BCTInitPacer(pPciPioBoardId)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTInitPacer returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Add a BLOCK_REPEATED_WRITE to the pacer list
    '---------------------------------------------------------------
    OutputMessage ("About to call BCTAddPacerBlockIo")
    nStatus = BCTAddPacerBlockIo(nPciPio1PortAHandle, pPciPioBoardId, BLOCK_REPEATED_WRITE, pPioBuffer, pPioBuffer, 256, 0)
    If (nStatus <> BCT_OK) And (nStatus <> BCT_IO_PENDING) Then
        Call BCTErr2Txt(nStatus, errorTxt)
        OutputMessage ("BCTAddPacerBlockIo returned: " + szErrorText)
        nStatus = BCTStopPacer(pPciPioBoardId)
    End If
    
    '---------------------------------------------------------------
    ' Start the pacer
    '---------------------------------------------------------------
    OutputMessage ("About to start the pacer")
    nStatus = BCTStartPacer(pPciPioBoardId, 30)   ' Change every 30ms
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, errorTxt)
        OutputMessage ("BCTStartPacer returned: " + szErrorText)
    End If
    
    '---------------------------------------------------------------
    ' Start the timer to do the read
    '---------------------------------------------------------------
    ReadPacer.Enabled = True

End Sub

'---------------------------------------------------------------
' StopPacer_Click - Stop the pacer updating the value on PIO 1
'                   port A.
'
' Input  : None
' Return : None
'---------------------------------------------------------------

Private Sub StopPacer_Click()
    
szErrorText = Space(120)
    
    '---------------------------------------------------------------
    ' Stop the read timer
    '---------------------------------------------------------------
    ReadPacer.Enabled = False
    
    '---------------------------------------------------------------
    ' Stop the pacer
    '---------------------------------------------------------------
    OutputMessage ("About to stop the pacer with BCTStopPacer")
    nStatus = BCTStopPacer(pPciPioBoardId)
    If nStatus <> BCT_OK Then
        Call BCTErr2Txt(nStatus, szErrorText)
        OutputMessage ("BCTStopPacer returned: " + szErrorText)
    End If
    
End Sub
