/*
	Blue Chip Technology	Win32 Dynamic Link Library

	bluechip.h		This module contains manifest constants 
					and function prototypes needed by 
					applications builders.

	Version History ;

	0.1		DSB	22/10/97	Initial code
*/

#ifndef __BLUECHIP_H__
#define __BLUECHIP_H__

#define SZ_VERSION_DESCRIPTION  "Win32 V0.1"

#include "bctypes.h"

//	Function prototypes
#ifdef __cplusplus
extern "C"
{
#endif

DllExport BCT_DWORD WINAPI BCTGetBoardId(BCT_BOARD_ID *pBoardId, BCT_BOARDTYPE nDevType, BCT_WORD nBoard);

DllExport BCT_DWORD WINAPI BCTReleaseBoardId(BCT_BOARD_ID *pBoardId);

DllExport BCT_DWORD WINAPI BCTFindSerialNo(BCT_DWORD nSerial, BCT_BOARDTYPE *pBoardType, BCT_WORD *pBoard);

DllExport BCT_DWORD WINAPI BCTOpen(PBCT_HANDLE pHandle, BCT_BOARD_ID *pBoardId, BCT_DEVICETYPE nDevType, BCT_WORD nDev, BCT_WORD nPort);

DllExport BCT_DWORD WINAPI BCTClose(PBCT_HANDLE pHandle);

DllExport BCT_DWORD WINAPI BCTInit8255Modes(BCT_BOARD_ID *pBoardId, BCT_WORD nDev, 
									 BCT_8255_MODES nMode, BCT_DIRECTIONS nPortA, 
									 BCT_DIRECTIONS nPortB, BCT_DIRECTIONS nPortC);

DllExport BCT_DWORD WINAPI BCTInitIsoDigModes(BCT_BOARD_ID *pBoardId, BCT_WORD nDev, 
									 BCT_8255_MODES nMode, BCT_DIRECTIONS nPortA, 
									 BCT_DIRECTIONS nPortB, BCT_DIRECTIONS nPortC);

DllExport BCT_DWORD WINAPI BCTInitAOutModes(BCT_BOARD_ID *pBoardId, BCT_WORD nDev, 
									 BCT_WORD nChan0, BCT_WORD nChan1, 
									 BCT_WORD nChan2, BCT_WORD nChan3);

DllExport BCT_DWORD WINAPI BCTReadPort(PBCT_HANDLE pHandle, BCT_BYTE *nVal);
DllExport BCT_DWORD WINAPI BCTReadPort16(PBCT_HANDLE pHandle, BCT_WORD *nVal);
DllExport BCT_DWORD WINAPI BCTReadPortAin(PBCT_HANDLE pHandle, BCT_BYTE nChan, BCT_BYTE nGain, 
								   BCT_BYTE nMode, BCT_WORD *nVal);

DllExport BCT_DWORD WINAPI BCTWritePort(PBCT_HANDLE pHandle, BCT_BYTE nVal);
DllExport BCT_DWORD WINAPI BCTWritePort16(PBCT_HANDLE pHandle, BCT_WORD nVal);

DllExport BCT_DWORD WINAPI BCTWriteBit(PBCT_HANDLE pHandle, BCT_BYTE nBit, BCT_BYTE nVal);

DllExport BCT_DWORD WINAPI BCTProgramCounter(PBCT_HANDLE pHandle, BCT_BYTE nSource);

DllExport BCT_DWORD WINAPI BCTInitPacer(BCT_BOARD_ID *pBoardId);

DllExport BCT_DWORD WINAPI BCTStartPacer(BCT_BOARD_ID *pBoardId, BCT_DWORD nInterval);

DllExport BCT_DWORD WINAPI BCTStopPacer(BCT_BOARD_ID *pBoardId);

DllExport BCT_DWORD WINAPI BCTAddPacerFunction(BCT_BOARD_ID *pBoardId, BCT_HANDLER nOperation, 
										BCT_DWORD *pVal);

DllExport BCT_DWORD WINAPI BCTAddPacerBlockIo(PBCT_HANDLE pHandle, BCT_BOARD_ID *pBoardId, 
									  BCT_WORD nOperation, PBCT_BUFFER pBuffer1, 
									  PBCT_BUFFER pBuffer2, BCT_DWORD nBytes, BCT_DWORD nCount);
	
DllExport void WINAPI BCTErr2Txt(BCT_DWORD Code, char *txt);
DllExport BCT_DWORD WINAPI BCTWait(PBCT_HANDLE pHandle, BCT_DWORD delay);
DllExport BCT_DWORD WINAPI BCTInitHandle(PBCT_HANDLE pHandle);

DllExport BCT_DWORD WINAPI BCTAllocate(PBCT_BUFFER *pBctBuf, BCT_DWORD Length);
DllExport BCT_DWORD WINAPI BCTRelease(PBCT_BUFFER *pBctBuf);

DllExport BCT_DWORD WINAPI BCTAcquireAPacer(BCT_BOARD_ID *pBoardId);
DllExport BCT_DWORD WINAPI BCTReleaseAPacer(BCT_BOARD_ID *pBoardId);
DllExport BCT_DWORD WINAPI BCTReadBlockAin(BCT_BOARD_ID *pBoardId, PBCT_HANDLE pHandle, BCT_BYTE nChan, BCT_BYTE nGain, 
								   BCT_BYTE nMode, PBCT_BUFFER pBuffer, BCT_DWORD nSamples, 
								   BCT_WORD nTime);

DllExport BCT_DWORD WINAPI BCTAutoCalAin(PBCT_HANDLE pHandle, BCT_BYTE Gain, BCT_WORD *MeanZero, BCT_WORD *MeanFsd);

DllExport BCT_DWORD WINAPI BCTSetWdt(PBCT_HANDLE pHandle, PBCT_WDT_SETDATA pData);
DllExport BCT_DWORD WINAPI BCTReadWdt(PBCT_HANDLE pHandle, PBCT_WDT_READDATA pData);
DllExport BCT_DWORD WINAPI BCTWatchdog(PBCT_HANDLE pHandle, WATCHDOG_OPERATION nAction, BCT_BYTE *pData);

DllExport BCT_DWORD WINAPI BCTEnumerateBoards(BCT_WORD nBoard, BCT_BOARDTYPE *pBoardType, BCT_WORD *pBoard, BCT_DWORD *pSerial);
DllExport BCT_DWORD WINAPI BCTFindBoardNo(BCT_DWORD nSerial, BCT_BOARDTYPE *pBoardType, BCT_WORD *pBoard);
DllExport BCT_DWORD WINAPI BCTInitPCIDio(BCT_BOARD_ID *pBoardId, BCT_WORD nDev);

BCT_DWORD WINAPI BCTGetLastError(PBCT_HANDLE pHandle, BCT_DWORD *pErrCode);

#ifdef __cplusplus
}
#endif

#endif
